@ECHO OFF
REM ## music notation video generator from lilypond file %1\%2.ly
REM ## and its configuration file %1\%2.cfg; resulting video is in
REM ## %1\%2.mp4; a non-empty %3 parameter flags that temporary files
REM ## should be kept

SET avsFragmentFile=C:\video_files\@framePicImport.avsinc
SET keepTemporaryFiles=%3

PUSHD %1
REM -- preparation of a functional AviSynth script --
lilypond --png %2.ly
timidity %2.midi -Ow -o %2.wav
ECHO picturePattern = "%2-page%%d.png"  >%2.tmp
ECHO wavFileName = "%2.wav"  >>%2.tmp
COPY /b %2.tmp+%2.cfg+%avsFragmentFile% %2.avs >NUL

REM -- encoding for iPod --
SET x264options=--bitrate 700 --level 3 --nf --no-cabac --subme 6
SET x264options=%x264options% --analyse none --qpmin 16 --vbv-maxrate 1000
SET x264options=%x264options% --me umh --merange 12 --thread-input
SET x264options=%x264options% --progress --no-psnr

x264 %x264options% --output %2-(VIDEO).mp4 %2.avs
faac -b 128 -P -X -R 44100 -B 16 -C 2 --mpeg-vers 4 -o %2.aac %2.wav
nicmp4box -add %2.aac -add %2-(VIDEO).mp4 -new %2.mp4

REM -- cleanup --
IF NOT %keepTemporaryFiles%x==x GOTO :ENDIF
  DEL %2.tmp
  DEL %2.ps
  DEL %2-*.png
  DEL %2.midi
  DEL %2.wav
  DEL %2.avs
  DEL %2.aac
  DEL %2-(VIDEO).mp4
:ENDIF

POPD
